<?php

class Limex_Advd_Block_Adminhtml_Widget_Helpdesk_Metric
    extends Limex_Advd_Block_Adminhtml_Widget_Abstract_Metric
{
    public function isEnabled()
    {
        return Mage::helper('core')->isModuleEnabled('Limex_Helpdesk');
    }

    public function getGroup()
    {
        return 'Helpdesk';
    }

    public function getName()
    {
        return 'Number of tickets';
    }
    
    public function prepareOptions()
    {
        $all = array(
            array(
                'value' => '',
                'label' => Mage::helper('advr')->__('All')
            ),

            array(
                'value' => '0',
                'label' => Mage::helper('advr')->__('Unassigned')
            )
        );

        $statuses   = array_merge($all, Mage::getModel('helpdesk/status')->getCollection()->toOptionArray());
        $priorities = array_merge($all, Mage::getModel('helpdesk/priority')->getCollection()->toOptionArray());
        $owners     = array_merge($all, Mage::helper('helpdesk')->getAdminUserOptionArray());

        $this->_form->addField('status_ids', 'multiselect', array(
                'name'   => 'status_ids',
                'label'  => Mage::helper('advr')->__('Status'),
                'values' => $statuses,
                'value'  => $this->getParam('status_ids'),
            )
        );

        $this->_form->addField('priority_ids', 'multiselect', array(
                'name'   => 'priority_ids',
                'label'  => Mage::helper('advr')->__('Priority'),
                'values' => $priorities,
                'value'  => $this->getParam('priority_ids'),
            )
        );

        $this->_form->addField('owner_id', 'select', array(
                'name'   => 'owner_id',
                'label'  => Mage::helper('advr')->__('Ticket Owner'),
                'values' => $owners,
                'value'  => $this->getParam('owner_id'),
            )
        );

        return $this;
    }

    public function getMetricValue()
    {
        $value = $this->_getCollection()->count();

        return $value;
    }

    public function getMetricValueToCompare()
    {
        return false;
    }

    public function formatMetricValue($value)
    {
        return $value;
    }

    public function _getCollection()
    {
        $collection = Mage::getModel('helpdesk/ticket')->getCollection()
            ->addFieldToFilter('is_spam', false)
            ->addFieldToFilter('is_archived', 0);

        $priorityIds = $this->getParam('priority_ids', array());
        $statusIds = $this->getParam('status_ids', array());
        $ownerId = $this->getParam('owner_id', false);

        if ($priorityIds && count($priorityIds)) {
            $collection->addFieldToFilter('priority_id', $priorityIds);
        }

        if ($statusIds && count($statusIds)) {
            $collection->addFieldToFilter('status_id', $statusIds);
        }

        if ($ownerId != '') {
            $collection->addFieldToFilter('user_id', $ownerId);
        }

        return $collection;
    }
}