<?php
 


class Limex_Advr_Block_Adminhtml_Order_Day extends Limex_Advr_Block_Adminhtml_Order_Abstract
{
    public function _prepareLayout()
    {
        parent::_prepareLayout();
        
        $this->setHeaderText(Mage::helper('advr')->__('Sales By Day Of Week'));

        return $this;
    }

    protected function _prepareChart()
    {
        $this->setChartType('column');

        $this->_initChart()
            ->setXAxisType('category')
            ->setXAxisField('day_of_week')
            ;

        return $this;
    }

    protected function _prepareGrid()
    {
        $this->_initGrid()
            ->setDefaultSort('day_of_week')
            ->setDefaultDir('asc')
            ->setDefaultLimit(7)
            ->setPagerVisibility(false)
            ;

        return $this;
    }

    protected function _prepareCollection()
    {
        $collection = Mage::getModel('advr/report_sales')
            ->setBaseTable('sales/order')
            ->setFilterData($this->getFilterData())
            ->selectColumns($this->getVisibleColumns())
            ->groupByColumn('day_of_week')
            ;

        return $collection;
    }

    public function getColumns()
    {
        $columns = array(
            'day_of_week' => array(
                'header'              => 'Day',
                'type'                => 'text',
                'frame_callback'      => array(Mage::helper('advr/callback'), 'day'),
                'export_callback'     => array(Mage::helper('advr/callback'), 'day'),
                'totals_label'        => 'Total',
                'filter_totals_label' => 'Subtotal',
                'filter'              => false,
            ),
        );

        $columns += $this->getOrderTableColumns(true);

        return $columns;
    }
}